const U1_EI = 1 <<7;
const U2_EI = 1 <<11;
const U3_EI = 1 <<16;
const U4_EI = 1 <<21;
const JS_U4_EI = 1114112;          // 2**16 -> 2**20 + 65535

const split_u2 = (cd) => {
    let _0 = 0b110_00000 | ((cd>>6) & 0b000_11111);
    let _1 = 0b10_000000 | (cd & 0b00_111111);
    return([_0,_1])
}
const split_u3 = (cd) => {
    let _0 = 0b1110_0000 | ((cd>>12) & 0b0000_1111);
    let _1 = 0b10_000000 | ((cd>>6) & 0b00_111111);
    let _2 = 0b10_000000 | (cd & 0b00_111111);
    return([_0,_1,_2])
}
const split_u4 = (cd) => {
    let _0 = 0b11110_000 | ((cd>>18)  & 0b00000_111);
    let _1 = 0b10_000000 | ((cd>>12)  & 0b00_111111);
    let _2 = 0b10_000000 | ((cd>>6)   & 0b00_111111);
    let _3 = 0b10_000000 | (cd & 0b00_111111);
    return([_0,_1,_2,_3])
}

const split = (cd) => {
    if(cd<U1_EI) {
        return([cd])
    } else if(cd<U2_EI) {
        return(split_u2(cd))
    } else if(cd<U3_EI) {
        return(split_u3(cd))
    } else {
        return(split_u4(cd))
    }
}

const len=(cd) => {
    if(cd<U1_EI) {
        return(1)
    } else if(cd<U2_EI) {
        return(2)
    } else if(cd<U3_EI) {
        return(3)
    } else {
        return(4)
    }    
}


module.exports = {
    U1_EI,U2_EI,U3_EI,U4_EI,JS_U4_EI,
    split_u2,split_u3,split_u4,
    split,
    len,
}



